<?php

namespace Mediastrategi\PostNord\Api\Data;

/**
 * Interface MspostnordAssignmentInterface
 * @api
 * @since 1.0.0
 */
interface MspostnordAssignmentInterface extends \Magento\Framework\Api\ExtensibleDataInterface
{
    /**
     * @since 1.0.0
     */
    const KEY_SHIPPING_OPTION_ID = 'shipping_option_id';
    const KEY_SHIPPING_OPTION_NAME = 'shipping_option_name';
    const KEY_ADDITIONAL_SERVICES = 'additional_services';
    const KEY_SERVICE_POINT_ID = 'service_point_id';
    const KEY_SERVICE_POINT_NAME = 'service_point_name';


    /**
     * Get shipping option id
     *
     * @return string
     * @since 1.0.0
     */
    public function getShippingOptionId();

    /**
     * Set shipping option id
     *
     * @param $shippingOptionId
     *
     * @return $this
     * @since 1.0.0
     */
    public function setShippingOptionId($shippingOptionId);

    /**
     * Get shipping option name
     *
     * @return string
     * @since 1.0.0
     */
    public function getShippingOptionName();

    /**
     * Set shipping option name
     *
     * @param $shippingOptionName
     *
     * @return $this
     * @since 1.0.0
     */
    public function setShippingOptionName($shippingOptionName);

    /**
     * Get additional services
     *
     * @return string
     * @since 1.0.0
     */
    public function getAdditionalServices();

    /**
     * Set additional services
     *
     * @param $additionalServices
     *
     * @return $this
     * @since 1.0.0
     */
    public function setAdditionalServices($additionalServices);

    /**
     * Get service point id
     *
     * @return string
     * @since 1.0.0
     */
    public function getServicePointId();

    /**
     * Set service point id
     *
     * @param $servicePointId
     *
     * @return $this
     * @since 1.0.0
     */
    public function setServicePointId($servicePointId);

    /**
     * Get service point name
     *
     * @return string
     * @since 1.0.0
     */
    public function getServicePointName();

    /**
     * Set service point name
     *
     * @param $servicePointName
     *
     * @return $this
     * @since 1.0.0
     */
    public function setServicePointName($servicePointName);

    /**
     * Retrieve existing extension attributes object or create a new one.
     *
     * @return \Mediastrategi\PostNord\Api\Data\MspostnordAssignmentExtensionInterface|null
     * @since 1.0.0
     */
    public function getExtensionAttributes();

    /**
     * Set an extension attributes object.
     *
     * @param  \Mediastrategi\PostNord\Api\Data\MspostnordAssignmentExtensionInterface  $extensionAttributes
     *
     * @return $this
     * @since 1.0.0
     */
    public function setExtensionAttributes(
        \Mediastrategi\PostNord\Api\Data\MspostnordAssignmentExtensionInterface $extensionAttributes
    );
}
