<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Api;

interface ScheduleRepositoryInterface
{
    /**
     * Save Schedule
     *
     * @param  \Mediastrategi\PostNord\Api\Data\ScheduleInterface  $schedule
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \Mediastrategi\PostNord\Api\Data\ScheduleInterface $schedule
    );

    /**
     * Retrieve Schedule
     *
     * @param  string  $scheduleId
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function get($scheduleId);

    /**
     * Retrieve Schedule matching the specified criteria.
     *
     * @param  \Magento\Framework\Api\SearchCriteriaInterface  $searchCriteria
     *
     * @return \Mediastrategi\PostNord\Api\Data\ScheduleSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete Schedule
     *
     * @param  \Mediastrategi\PostNord\Api\Data\ScheduleInterface  $schedule
     *
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \Mediastrategi\PostNord\Api\Data\ScheduleInterface $schedule
    );

    /**
     * Delete Schedule by ID
     *
     * @param  string  $scheduleId
     *
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($scheduleId);
}
