<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Controller\Adminhtml\Dashboard;

class Index extends \Magento\Backend\App\Action
{
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    private $resultPageFactory;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $pageFactory
    ) {
        parent::__construct($context);
        $this->resultPageFactory = $pageFactory;
    }

    public function execute(): \Magento\Backend\Model\View\Result\Page
    {
        /** @var \Magento\Backend\Model\View\Result\Page $resultPage */
        $resultPage = $this->resultPageFactory->create();
        $resultPage->setActiveMenu('Mediastrategi_PostNord::wizard');
        $resultPage->getConfig()->getTitle()->prepend(__('PostNord Ship Connect'));
        return $resultPage;
    }

    /**
     * @SuppressWarnings(PHPMD.CamelCaseMethodName)
     * phpcs:disable PSR2.Methods.MethodDeclaration.Underscore
     */
    protected function _isAllowed(): bool
    {
        return $this->_authorization->isAllowed('Mediastrategi_PostNord::wizard');
    }
}
