<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Controller\Adminhtml\Misc;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\App\Action\HttpGetActionInterface;
use Magento\Framework\App\ResponseInterface;
use Magento\Framework\Controller\ResultInterface;
use Magento\Framework\Exception\NotFoundException;
use Mediastrategi\PostNord\Helper\ApiTransaction;

class CleanTransactions extends Action implements HttpGetActionInterface
{
    /**
     * Authorization level of a basic admin session
     */
    const ADMIN_RESOURCE = 'Mediastrategi_PostNord::Transaction_delete';
    /**
     * @var ApiTransaction
     */
    private $apiTransactionHelper;

    public function __construct(
        Context $context,
        ApiTransaction $apiTransactionHelper
    ) {
        parent::__construct($context);
        $this->apiTransactionHelper = $apiTransactionHelper;
    }

    /**
     * Execute action based on request and return result
     *
     * @return ResultInterface|ResponseInterface
     * @throws NotFoundException
     */
    public function execute()
    {
        $this->apiTransactionHelper->clean();

        return $this->resultRedirectFactory->create()->setPath('mspostnord/misc/transactions');
    }
}
