<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Model\Order;

use Magento\Framework\Model\AbstractExtensibleModel;
use Mediastrategi\PostNord\Api\Data\MspostnordAssignmentInterface;

class MspostnordAssignment extends AbstractExtensibleModel implements MspostnordAssignmentInterface
{
    /**
     * {@inheritdoc}
     */
    public function getExtensionAttributes()
    {
        return $this->_getExtensionAttributes();
    }

    /**
     * {@inheritdoc}
     */
    public function setExtensionAttributes(
        \Mediastrategi\PostNord\Api\Data\MspostnordAssignmentExtensionInterface $extensionAttributes
    ) {
        return $this->_setExtensionAttributes($extensionAttributes);
    }

    /**
     * @inheritDoc
     */
    public function getShippingOptionId()
    {
        return $this->getData(self::KEY_SHIPPING_OPTION_ID);
    }

    /**
     * @inheritDoc
     */
    public function setShippingOptionId($shippingOptionId)
    {
        return $this->setData(self::KEY_SHIPPING_OPTION_ID, $shippingOptionId);
    }

    /**
     * @inheritDoc
     */
    public function getShippingOptionName()
    {
        return $this->getData(self::KEY_SHIPPING_OPTION_NAME);
    }

    /**
     * @inheritDoc
     */
    public function setShippingOptionName($shippingOptionName)
    {
        return $this->setData(self::KEY_SHIPPING_OPTION_NAME, $shippingOptionName);
    }

    /**
     * @inheritDoc
     */
    public function getAdditionalServices()
    {
        return $this->getData(self::KEY_ADDITIONAL_SERVICES);
    }

    /**
     * @inheritDoc
     */
    public function setAdditionalServices($additionalServices)
    {
        return $this->setData(self::KEY_ADDITIONAL_SERVICES, $additionalServices);
    }

    /**
     * @inheritDoc
     */
    public function getServicePointId()
    {
        return $this->getData(self::KEY_SERVICE_POINT_ID);
    }

    /**
     * @inheritDoc
     */
    public function setServicePointId($servicePointId)
    {
        return $this->setData(self::KEY_SERVICE_POINT_ID, $servicePointId);
    }

    /**
     * @inheritDoc
     */
    public function getServicePointName()
    {
        return $this->getData(self::KEY_SERVICE_POINT_NAME);
    }

    /**
     * @inheritDoc
     */
    public function setServicePointName($servicePointName)
    {
        return $this->setData(self::KEY_SERVICE_POINT_NAME, $servicePointName);
    }
}
