<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Model;

/**
 * @SuppressWarnings(PHPMD.CamelCasePropertyName)
 * phpcs:disable PSR2.Classes.PropertyDeclaration.Underscore
 */
class OrderData extends \Magento\Framework\Model\AbstractModel
{
    protected $orderDataDataFactory;
    protected $dataObjectHelper;
    protected $_eventPrefix = 'mediastrategi_postnord_orderdata';

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Mediastrategi\PostNord\Api\Data\OrderDataInterfaceFactory $orderDataDataFactory,
        \Magento\Framework\Api\DataObjectHelper $dataObjectHelper,
        \Mediastrategi\PostNord\Model\ResourceModel\OrderData $resource,
        \Mediastrategi\PostNord\Model\ResourceModel\OrderData\Collection $resourceCollection,
        array $data = []
    ) {
        $this->orderDataDataFactory = $orderDataDataFactory;
        $this->dataObjectHelper = $dataObjectHelper;
        parent::__construct(
            $context,
            $registry,
            $resource,
            $resourceCollection,
            $data
        );
    }

    /**
     * @SuppressWarnings(PHPMD.CamelCaseMethodName)
     * phpcs:disable PSR2.Methods.MethodDeclaration.Underscore
     */
    protected function _construct(): void
    {
        $this->_init(
            ResourceModel\OrderData::class
        );
    }

    public function getDataModel(): \Mediastrategi\PostNord\Api\Data\OrderDataInterface
    {
        $orderDataData = $this->getData();
        $orderDataDataObject =
            $this->orderDataDataFactory->create();
        $this->dataObjectHelper->populateWithArray(
            $orderDataDataObject,
            $orderDataData,
            \Mediastrategi\PostNord\Api\Data\OrderDataInterface::class
        );
        return $orderDataDataObject;
    }
}
