<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\Model;

/**
 * @SuppressWarnings(PHPMD.CamelCasePropertyName)
 * phpcs:disable PSR2.Classes.PropertyDeclaration.Underscore
 */
class PersistentQuote extends \Magento\Framework\Model\AbstractModel
{
    protected $persistentquoteDataFactory;
    protected $dataObjectHelper;
    protected $_eventPrefix = 'mediastrategi_postnord_persistentquote';

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterfaceFactory $persistentquoteDataFactory,
        \Magento\Framework\Api\DataObjectHelper $dataObjectHelper,
        \Mediastrategi\PostNord\Model\ResourceModel\PersistentQuote $resource,
        \Mediastrategi\PostNord\Model\ResourceModel\PersistentQuote\Collection $resourceCollection,
        array $data = []
    ) {
        $this->persistentquoteDataFactory = $persistentquoteDataFactory;
        $this->dataObjectHelper = $dataObjectHelper;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * @SuppressWarnings(PHPMD.CamelCaseMethodName)
     * phpcs:disable PSR2.Methods.MethodDeclaration.Underscore
     */
    protected function _construct(): void
    {
        $this->_init(
            ResourceModel\PersistentQuote::class
        );
    }

    /**
     * Retrieve persistentquote model with persistentquote data
     */
    public function getDataModel(): \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface
    {
        $persistentquoteData = $this->getData();
        $persistentquoteDataObject =
            $this->persistentquoteDataFactory->create();
        $this->dataObjectHelper->populateWithArray(
            $persistentquoteDataObject,
            $persistentquoteData,
            \Mediastrategi\PostNord\Api\Data\PersistentQuoteInterface::class
        );

        return $persistentquoteDataObject;
    }
}
