<?php

declare(strict_types=1);

namespace Mediastrategi\PostNord\ViewModel\Adminhtml;

class Dashboard implements \Magento\Framework\View\Element\Block\ArgumentInterface
{
    /**
     * @var \Mediastrategi\PostNord\Helper\Meta
     */
    private $metaHelper;
    /**
     * @var \Magento\Framework\UrlInterface
     */
    private $urlBuilder;

    public function __construct(
        \Mediastrategi\PostNord\Helper\Meta $metaHelper,
        \Magento\Framework\UrlInterface $urlBuilder
    ) {
        $this->metaHelper = $metaHelper;
        $this->urlBuilder = $urlBuilder;
    }

    public function getTesterUrl(): string
    {
        return $this->urlBuilder->getUrl('mspostnord/misc/test');
    }

    public function getScheduleLogUrl(): string
    {
        return $this->urlBuilder->getUrl('mspostnord/misc/schedulelog');
    }

    public function isDebug(): bool
    {
        return $this->metaHelper->isDebug();
    }

    public function getTransactionsUrl(): string
    {
        return $this->urlBuilder->getUrl('mspostnord/misc/transactions');
    }

    public function getConfigureUrl(): string
    {
        return $this->urlBuilder->getUrl('adminhtml/system_config/edit/section/carriers/mediastrategi_postnord');
    }

    public function hasValidConfiguration(): bool
    {
        return ($this->metaHelper->getConfigurationErrors()
                == false);
    }

    public function getRunAutomationUrl(): string
    {
        return $this->urlBuilder->getUrl('mspostnord/misc/automation');
    }

    public function getSupportEmailLink(): string
    {
        return $this->metaHelper->getSupportEmailLink();
    }
}
